//////////////////////////////////////////////////////////////////////
// runNet.java
// 2005.03.07 by Geof Fang
// This file runs the previously trained neural net on a file
// of input data, and presents the result as a confidence level.
// This allows for discrimination of objects as being targets vs
// non-targets.
//
// Revision History:
// 2005.03.07 Initial Write
//////////////////////////////////////////////////////////////////////

import java.io.*;

public class runNet
{
  static double temp = 0.0;
  static public void main( String args[] ) throws Exception
  {
    BufferedWriter out;
    ///\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/\_/
		
    // now recreate the net using previously saved data and
    // use the trained net to calculate some numbers.
    // You could use this part in a separate java class.
		
    // Create the net from saved data.
    Randomizer randomizer = new Randomizer();
    System.out.println("Loading the saved net...");
    NeuralNet myNet = new NeuralNet("heimdall.nnc", randomizer);
    myNet.LoadWeights("heimdall.nnw");
    out = new BufferedWriter( new FileWriter( "heimdalls_results.dat" ) );
 		
    // Run the file through the net, output the confidence levels both
    // to the screen, and a results file.
    // Read lines from the input file
    LineReader lr = new LineReader( "heimdall_test.csv" );
    // Create a new double array for the features
    double[] inputs = new double[4];
    while( lr.NextLineSplitted() )
    {
      try
      {
        for( int i = 0; i < 4; ++i )
        {
	  // Add the file contents to the input array
          inputs[i] = Double.parseDouble( lr.column[i + 1] );
	}
	  // Create the output array (1 value)
	  double[] output = myNet.Output( inputs );
	  // Write out to the results file the descriptor and output
	  out.write( lr.column[0] );
	  out.write( ";" );
	  out.write( Double.toString( .5 * ( output[0] + 1 ) ) );
	  out.newLine();
	  // Print out the results to the screen
	  System.out.print( lr.column[0] );
	  System.out.println( "\n\t" + Double.toString( .5 * ( output[0] + 1 ) ) );
	  //System.out.println( "Error: " + Double.toString( ((inputs[0] + inputs[1]) * inputs[2]) - output[0] ) );
      }
      catch( IOException ioe )
      {
        System.out.println( "Error writing to the results file!" );
      }
    }
    out.close();
  }
}
